<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::libcurlUtils::HttpPostInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html">libcurlUtils</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html">HttpPostInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::libcurlUtils::HttpPostInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Minimal interface for making Http POST requests.  
 <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_http_post_interface_8h_source.html">HttpPostInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::utils::libcurlUtils::HttpPostInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post.html" title="LIBCURL based implementation of HttpPostInterface. " alt="" coords="5,105,202,157"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:af639e49be5f37abc547ce1d48ed795fc"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html#af639e49be5f37abc547ce1d48ed795fc">~HttpPostInterface</a> ()=default</td></tr>
<tr class="memdesc:af639e49be5f37abc547ce1d48ed795fc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual destructor to assure proper cleanup of derived types.  <a href="#af639e49be5f37abc547ce1d48ed795fc">More...</a><br /></td></tr>
<tr class="separator:af639e49be5f37abc547ce1d48ed795fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad7fc905e46363f396633c9810e385ae3"><td class="memItemLeft" align="right" valign="top">virtual long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html#ad7fc905e46363f396633c9810e385ae3">doPost</a> (const std::string &amp;url, const std::string &amp;data, std::chrono::seconds timeout, std::string &amp;body)=0</td></tr>
<tr class="separator:ad7fc905e46363f396633c9810e385ae3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a059bca0529e9729b1787608f0e691a4f"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">HTTPResponse</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html#a059bca0529e9729b1787608f0e691a4f">doPost</a> (const std::string &amp;url, const std::vector&lt; std::string &gt; headerLines, const std::vector&lt; std::pair&lt; std::string, std::string &gt;&gt; &amp;data, std::chrono::seconds timeout)=0</td></tr>
<tr class="separator:a059bca0529e9729b1787608f0e691a4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a31dd16dad5b37896bc503ef7b8db3ca6"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">HTTPResponse</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html#a31dd16dad5b37896bc503ef7b8db3ca6">doPost</a> (const std::string &amp;url, const std::vector&lt; std::string &gt; headerLines, const std::string &amp;data, std::chrono::seconds timeout)=0</td></tr>
<tr class="separator:a31dd16dad5b37896bc503ef7b8db3ca6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Minimal interface for making Http POST requests. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="af639e49be5f37abc547ce1d48ed795fc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af639e49be5f37abc547ce1d48ed795fc">&#9670;&nbsp;</a></span>~HttpPostInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::avsCommon::utils::libcurlUtils::HttpPostInterface::~HttpPostInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Virtual destructor to assure proper cleanup of derived types. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ad7fc905e46363f396633c9810e385ae3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad7fc905e46363f396633c9810e385ae3">&#9670;&nbsp;</a></span>doPost() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual long alexaClientSDK::avsCommon::utils::libcurlUtils::HttpPostInterface::doPost </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::chrono::seconds&#160;</td>
          <td class="paramname"><em>timeout</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string &amp;&#160;</td>
          <td class="paramname"><em>body</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Perform an HTTP Post request returning the response body as a string. This method blocks for the duration of the request.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">url</td><td>The URL to send the POST to. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">data</td><td>The POST data to send in the request. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">timeout</td><td>The maximum amount of time (in seconds) to wait for the request to complete. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">body</td><td>A string to receive the body of the request if there is one. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A HttpStatus indicating the disposition of the Post request. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post.html#a3671356a2dde6f0ea62df504078d35de">alexaClientSDK::avsCommon::utils::libcurlUtils::HttpPost</a>.</p>

</div>
</div>
<a id="a059bca0529e9729b1787608f0e691a4f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a059bca0529e9729b1787608f0e691a4f">&#9670;&nbsp;</a></span>doPost() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">HTTPResponse</a> alexaClientSDK::avsCommon::utils::libcurlUtils::HttpPostInterface::doPost </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt;&#160;</td>
          <td class="paramname"><em>headerLines</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::pair&lt; std::string, std::string &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::chrono::seconds&#160;</td>
          <td class="paramname"><em>timeout</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Perform an HTTP Post request returning the response body as a string. This method blocks for the duration of the request.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">url</td><td>The URL to send the POST to. </td></tr>
    <tr><td class="paramname">headerLines</td><td>vector of strings to add as header lines. </td></tr>
    <tr><td class="paramname">data</td><td>Key, value pairs describing the POST data to send in the request. This keys and values will be URL encoded by this method. </td></tr>
    <tr><td class="paramname">timeout</td><td>The maximum amount of time (in seconds) to wait for the request to complete. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>An object describing the response to the request. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post.html#ab66d452b5d491983aa70457b9cf60683">alexaClientSDK::avsCommon::utils::libcurlUtils::HttpPost</a>.</p>

</div>
</div>
<a id="a31dd16dad5b37896bc503ef7b8db3ca6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a31dd16dad5b37896bc503ef7b8db3ca6">&#9670;&nbsp;</a></span>doPost() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">HTTPResponse</a> alexaClientSDK::avsCommon::utils::libcurlUtils::HttpPostInterface::doPost </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt;&#160;</td>
          <td class="paramname"><em>headerLines</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::chrono::seconds&#160;</td>
          <td class="paramname"><em>timeout</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Perform an HTTP Post request returning the response body as a string. This method blocks for the duration of the request.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">url</td><td>The URL to send the POST to. </td></tr>
    <tr><td class="paramname">headerLines</td><td>vector of strings to add as header lines. </td></tr>
    <tr><td class="paramname">data</td><td>A string containing the POST data to send in the request. </td></tr>
    <tr><td class="paramname">timeout</td><td>The maximum amount of time (in seconds) to wait for the request to complete. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>An object describing the response to the request. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post.html#a4cc23ad8e1aad62298ce95c40f38aae9">alexaClientSDK::avsCommon::utils::libcurlUtils::HttpPost</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/include/AVSCommon/Utils/LibcurlUtils/<a class="el" href="_http_post_interface_8h_source.html">HttpPostInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
